import requests
# encoding = utf-8

def process_event(helper, *args, **kwargs):
    """
    # IMPORTANT
    # Do not remove the anchor macro:start and macro:end lines.
    # These lines are used to generate sample code. If they are
    # removed, the sample code will not be updated when configurations
    # are updated.

    [sample_code_macro:start]

    # The following example gets the alert action parameters and prints them to the log
    token = helper.get_param("token")
    helper.log_info("token={}".format(token))

    chat_id = helper.get_param("chat_id")
    helper.log_info("chat_id={}".format(chat_id))

    message = helper.get_param("message")
    helper.log_info("message={}".format(message))

    disable_notification = helper.get_param("disable_notification")
    helper.log_info("disable_notification={}".format(disable_notification))


    # The following example adds two sample events ("hello", "world")
    # and writes them to Splunk
    # NOTE: Call helper.writeevents() only once after all events
    # have been added
    helper.addevent("hello", sourcetype="sample_sourcetype")
    helper.addevent("world", sourcetype="sample_sourcetype")
    helper.writeevents(index="summary", host="localhost", source="localhost")

    # The following example gets the events that trigger the alert
    events = helper.get_events()
    for event in events:
        helper.log_info("event={}".format(event))

    # helper.settings is a dict that includes environment configuration
    # Example usage: helper.settings["server_uri"]
    helper.log_info("server_uri={}".format(helper.settings["server_uri"]))
    [sample_code_macro:end]
    """

    helper.log_info("Alert action telegram started.")
    token = helper.get_param("token")
    helper.log_info("token={}".format(token))
    chat_id = helper.get_param("chat_id")
    message = helper.get_param("message")
    disable_notification = helper.get_param("disable_notification")
    
    response = requests.post(
        url='https://api.telegram.org/bot{}/sendMessage'.format(token),
        data={
            'chat_id': '{}'.format(chat_id),
            'text': message,
            'disable_notification': disable_notification
        }
    )
    helper.log_info("status={}, content={}".format(response.status_code, response.content))
    
    # TODO: Implement your alert action logic here
    return 0
