import requests
from time import sleep
from telebot import TeleBot, apihelper
import json
import splAuth

apihelper.proxy = {'http': '', 'https': '', 'ftp': ''}
bot = TeleBot('#### BOT TOKEN ####')

SPLUNK_URL = 'https://localhost:8089/services/search/jobs/'
SPLUNK_DATA_URL = 'https://localhost:8089/services/search/jobs/{}/results?output_mode=json'

@bot.message_handler(commands=['query'])
def query_message(message):
    try:
        query = 'search index=_internal earliest=-15m latest=now | stats count'
        bot.send_message(message.chat.id, query)
        bot.send_message(message.chat.id, "Ask Splunk ...")
        s = requests.Session()
        s.auth = (splAuth.spl_login, splAuth.spl_pass)
        sid = s.post(SPLUNK_URL, data={'search': query, 'output_mode': 'json'}, verify=False).json()['sid']
        sid = sid.encode('utf8')
        sleep(5)

        data = s.get(SPLUNK_DATA_URL.format(sid), verify=False).json()

        bot.send_message(message.chat.id, json.dumps(data['results'], indent=4, sort_keys=True))
    except (KeyError, ValueError):
        bot.send_message(message.chat.id, 'Response is empty')
    except requests.ConnectionError:
        bot.send_message(message.chat.id, 'Server not available')

@bot.message_handler(commands=['logondata'])
def query_message(message):
    try:
        query = 'search index=_internal action=login |  table _time user status'
        bot.send_message(message.chat.id, query)
        bot.send_message(message.chat.id, "Ask Splunk ...")
        s = requests.Session()
        s.auth = (splAuth.spl_login, splAuth.spl_pass)
        sid = s.post(SPLUNK_URL, data={'search': query, 'output_mode': 'json'}, verify=False).json()['sid']
        sid = sid.encode('utf8')
        sleep(5)

        data = s.get(SPLUNK_DATA_URL.format(sid), verify=False).json()

        bot.send_message(message.chat.id, json.dumps(data['results'], indent=4, sort_keys=True))
    except (KeyError, ValueError):
        bot.send_message(message.chat.id, 'Response is empty')
    except requests.ConnectionError:
        bot.send_message(message.chat.id, 'Server not available')




if __name__ == '__main__':
    bot.remove_webhook()
    bot.polling(none_stop=True)